program fifoclient;

uses
   SysUtils, Pipes;

const
   PIPE_NAME = '/tmp/fifotest';

var
   fifo : TNamedPipe;
   tmpstr : string;
   sendBuf : TPipeBuffer;

begin
   writeln('Starting fifo Client..');
   fifo := TNamedPipe.Create( PIPE_NAME, psWrite, 
                              [fpOwnerRead, fpOwnerWrite,
                               fpGroupRead, fpGroupWrite]);

   tmpstr := 'Hello from a fifo client!';
   SetLength(sendBuf,length(tmpstr));   
   StrPCopy(PChar(sendBuf),tmpstr);

   if not fifo.Write(sendBuf, length(sendBuf)) then
      writeln('Client: error writing to fifo!')
   else
      writeln('Message successfully sent!');

   fifo.Free;

   writeln('Client is done.');
end.

