program fifoserver;

uses
   SysUtils, Pipes;

const
   PIPE_NAME = '/tmp/fifotest';

var
   fifo : TNamedPipe;
   recvBuf : TPipeBuffer;

begin
   writeln('Starting fifo server...');
   fifo := TNamedPipe.Create( PIPE_NAME, psRead, 
                              [fpOwnerRead, fpOwnerWrite,
                               fpGroupRead, fpGroupWrite]);

   SetLength(recvBuf,1024);   
   if not fifo.Read(recvBuf, length(recvBuf)) then
      writeln('Server: Error reading from fifo!')
   else
      writeln('Received ->',StrPas(PChar(recvBuf)),'<- from a client');

   fifo.Free;

   writeln('Server is done.');
end.

