program PipeTest;

uses
  SysUtils,Pipes;

const 
  PIPE_NAME = '/tmp/fifo.1';

var
  pipe : TPipe;
  tmpbuf : string;
  sendBuf : TPipeBuffer;
  recvBuf : TPipeBuffer;

begin
  pipe := TPipe.Create;

  tmpbuf := 'Hello Pipe world!';
  SetLength(sendBuf,length(tmpbuf)+1);
  StrPCopy(PChar(sendBuf),tmpbuf);

  // write something on one end and see 
  // if we get the same thing on the read side
  if not pipe.Write(sendBuf, length(sendBuf)) then
     writeln('Error writing buffer!');

  SetLength(recvBuf,length(tmpbuf)+1);
  
  // now read something on the other end
  if not pipe.Read(recvBuf, length(recvBuf)) then
     writeln('Error reading buffer!');

  writeln('Hey I got the following from the pipe ->',StrPas(PChar(recvBuf)),'<--');
  pipe.Free;
end.
